%this function is called by the GUI on speech compression
%it will accept as input the signal, wavelet ,number of decomposition level, and the multipliaction factor for threshold
%return values are given below.
%signicoefs = non-zero DWT coefficients
%zeropos = the zero postions. while encoding, we need to store the number of zeros and their positions, which is done in this vector
%L is the book-keeping vector
%coeflen is the length of original wavelet coefficient vector
%XC is the reconstructed signal
%C is the wavelet coefficient vector
%CXC is the compressed coefficient vector
%PERFO and PERFL2 are performances parameters. See MATLAB help on 'wdencmp' for details

%programmer---- SHIVRAMAN GIRI
%---------------BE ELECTRONICS
%---------------VJTI, MUMBAI
%email----------shivpap@hotmail.com

function [signicoefs,zeropos,L,coeflen,XC,C,CXC,PERF0,PERFL2] = compress(signaly,wlet,decomplevel,mulfact);

%perform the wavelet decomposition of the signal
[C,L] = wavedec(signaly,decomplevel,wlet);

%compute the default threshold 
[thr,sorh,keepapp] = ddencmp('cmp','wv',signaly);

%multiply the default threshold by the factor, mulfact
thr=thr*mulfact;

%compress the signal, ie truncate the insignificant coefficients
[XC,CXC,LXC,PERF0,PERFL2] = wdencmp('gbl',C,L,wlet,decomplevel,thr,sorh,keepapp);

%this is a user defined function. see its code for details
[signicoefs,zeropos]=encode1(CXC);
coeflen=length(CXC);
