%this  script file will read a MAT-file with a 'comp' prefix
%the 'comp' prefix indicates that the MAT-file contains data like sampling rate, wavelet, decomposition level, and other information used for reconstruction

%programmer---- SHIVRAMAN GIRI
%---------------BE ELECTRONICS
%---------------VJTI, MUMBAI
%email----------shivpap@hotmail.com
msgbox('You need to select a file to decompress. The compressed files have a prefix of "comp" .Selection of unsuitable files will lead to erroneous results.Press "OK"  and then press any key','Warning !');

pause;
[fname,pname] = uigetfile('*.mat','Select a file to decompress');


if  ~(fname)
else 
mystr=[pname,fname];
load(mystr);


%recollect that the signicoefs is supposed to be a vector of double precision 
%we converted it to a vector of integers for disk space savings.
% see the code for menu option for saving the 'compressed and encoded signal'. the tag is 'mnusave4'. see the callback function in the M-file speechcomp.m.
%now we get back our double precision coeffs. we also need to divide this by 10000, the reverse of what we did while compressing.
%note that we can retrieve only upto 4th decimal places of the significant coeffs. its a fair approximation
mydata.signicoefs=double(mydata.signicoefs);
mydata.signicoefs=mydata.signicoefs/10000;

%get the coefficient matrix
b=decode1(mydata.signicoefs,mydata.zeropos,mydata.coeflength); 

%reconstruct the signal
m=waverec(b,mydata.Lvalues,mydata.wavelet);          

%following lines will create a path for the reconstructed output 
%the last 3 character which define a MAT-file are replaced by 'wav'
%the previous variable 'mystr' is used; it is redifined here.
          n=length(fname)-3;
          mystr=[fname(5:n),'wav'];
          outputpath=[pname,'recon',mystr];
          

wavwrite(m,mydata.FS,mydata.BPS,outputpath);

msgbox(['The reconstructed audio file is    ',outputpath],'Reconstruction successful!')

end 