%this graphical user interface,GUI, will read .wav files and perform compression on them using wavelet methods

%programmer---- SHIVRAMAN GIRI
%---------------BE ELECTRONICS
%---------------VJTI, MUMBAI
%email----------shivpap@hotmail.com

function varargout = speechcomp(varargin)
% SPEECHCOMP Application M-file for speechcomp.fig
%    FIG = SPEECHCOMP launch speechcomp GUI.
%    SPEECHCOMP('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.0 19-Jul-2003 09:36:37

if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
	guidata(fig, handles);

    %the following lines are added by me, shivraman giri, to disable the save and plot menus  at start
set(handles.mnusave,'enable','off');
set(handles.mnuplotting,'enable','off');
set(handles.mnucoeffs,'enable','off');
    
    
	if nargout > 0
		varargout{1} = fig;
	end

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		if (nargout)
			[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
		else
			feval(varargin{:}); % FEVAL switchyard
		end
	catch
		disp(lasterr);
	end

 
    
end


%| ABOUT CALLBACKS:
%| GUIDE automatically appends subfunction prototypes to this file, and 
%| sets objects' callback properties to call them through the FEVAL 
%| switchyard above. This comment describes that mechanism.
%|
%| Each callback subfunction declaration has the following form:
%| <SUBFUNCTION_NAME>(H, EVENTDATA, HANDLES, VARARGIN)
%|
%| The subfunction name is composed using the object's Tag and the 
%| callback type separated by '_', e.g. 'slider2_Callback',
%| 'figure1_CloseRequestFcn', 'axis1_ButtondownFcn'.
%|
%| H is the callback object's handle (obtained using GCBO).
%|
%| EVENTDATA is empty, but reserved for future use.
%|
%| HANDLES is a structure containing handles of components in GUI using
%| tags as fieldnames, e.g. handles.figure1, handles.slider2. This
%| structure is created at GUI startup using GUIHANDLES and stored in
%| the figure's application data using GUIDATA. A copy of the structure
%| is passed to each callback.  You can store additional information in
%| this structure at GUI startup, and you can change the structure
%| during callbacks.  Call guidata(h, handles) after changing your
%| copy to replace the stored original so that subsequent callbacks see
%| the updates. Type "help guihandles" and "help guidata" for more
%| information.
%|
%| VARARGIN contains any extra arguments you have passed to the
%| callback. Specify the extra arguments by editing the callback
%| property in the inspector. By default, GUIDE sets the property to:
%| <MFILENAME>('<SUBFUNCTION_NAME>', gcbo, [], guidata(gcbo))
%| Add any extra arguments after the last argument, before the final
%| closing parenthesis.



% --------------------------------------------------------------------
function varargout = mnufile_Callback(h, eventdata, handles, varargin)




% --------------------------------------------------------------------
function varargout = mnuload_Callback(h, eventdata, handles, varargin)
fig = openfig(mfilename,'reuse');



[fname,pname] = uigetfile('*.wav','Select the M-file');


%ascertain if the user has pressed cancel in the common dialog box  while selecting a file
if ~(fname) 
else
        handles.pathname=pname;
        handles.filename=fname;          %u need not save pname and fname in the structure, use a local variable instead
        handles.inputwavefile=[pname,fname];
        guidata(fig,handles);

        %load the signal and the details viz sampling rate FS and bits per sec BPS
        [handles.y,handles.FS,handles.BPS]=wavread(handles.inputwavefile);
        guidata(fig,handles);

        
        
        %activate  this button
        set(handles.cmdcompress,'enable','on');
        
         %suppose you load a second signal. The button "compresss" has not been pressed.
         %to prevent the user from saving or plotting anything at this stage, you must disbale the save  and plot options
         %it is enabled after the compress is pressed
          set(handles.mnusave,'enable','off');
          set(handles.mnuplotting,'enable','off'); 
          set(handles.mnucoeffs,'enable','off'); 
          
          %plot the signal
          axes(handles.axes_signal); % Select the proper axes
          n=1:length(handles.y);
          plot(n,handles.y);
          grid on;
          
          %the labeling on both the axes should be in red
          set(handles.axes_signal,'XColor','red');
          set(handles.axes_signal,'YColor','red');
          
          
          %make the graph visible and the message invisible
          set(handles.axes_signal,'Visible','on');
          set(handles.lblmessage1,'visible','off');
          set(handles.lblmessage2,'visible','off');
          set(handles.lblmessage3,'visible','off');
          set(handles.lblmessage4,'visible','off');
          set(handles.lblmessage5,'visible','off')
          
          %everytime a new signal is loaded, the results should be concealed.Also, the status of compression must be hidden.
          set(handles.frame3,'visible','on');   %frame3 covers the results block
          set(handles.lblstatus,'visible','off');   %the status is hidden
    end



% --------------------------------------------------------------------




% --------------------------------------------------------------------
function varargout = txtinputlength_Callback(h, eventdata, handles, varargin)




% --------------------------------------------------------------------





% --------------------------------------------------------------------
function varargout = cmdcompress_Callback(h, eventdata, handles, varargin)

%display the message that the compression is in progress
set(handles.lblstatus,'string','Compressing......please wait');
set(handles.lblstatus,'visible','on');
set(handles.lblstatus,'backgroundcolor','red');

% make the results invisible by covering it up with  the frame3, so that objects behind it cant  be viewed  when compressing
 set(handles.frame3,'visible','on');



fig = openfig(mfilename,'reuse');   %used to specify that the FIG file is opened. check help on openfig



%store the wavelet and decomp level in a structure, so that we may save that structure in a mat file
handles.wavelet=get(handles.txtwavelet,'string');
handles.decomplevel=str2num(get(handles.txtdecomplevel,'string'));
guidata(fig,handles);

mulfactforthr=str2num(get(handles.txtthrmulfact,'string'));  %multiplication factor for threshold
%since mulfactforthr is not used for reconstruction, no need of storing it in a structure



% the compressed  significant coefficient vector is stored in handles.signicoefs
%zero positions and number of zeros stored in handles.zeropos
% coeflength is the length of coef vector
[handles.signicoefs,handles.zeropos,handles.Lvalues,handles.coeflength,handles.reconX,handles.C,handles.CXC,PERF0,PERFL2]=compress(handles.y,handles.wavelet,handles.decomplevel,mulfactforthr);
guidata(fig,handles);



%display the message that the compression is finished
set(handles.lblstatus,'string','Finished compressing');
set(handles.lblstatus,'visible','on');
set(handles.lblstatus,'backgroundcolor','green');


% Now all the quantities to be save have appeared, so the save and plot  menus can be enabled
 set(handles.mnusave,'enable','on');
 set(handles.mnuplotting,'enable','on');
  set(handles.mnucoeffs,'enable','on');
 
 
 %now to display the results
 set(handles.text25,'String',num2str(length(handles.y)));
 set(handles.text26,'String',num2str(handles.FS));
 set(handles.text27,'string',num2str(length(handles.signicoefs)+length(handles.zeropos)+length(handles.Lvalues)));
 
compression_ratio=length(handles.y)/(length(handles.signicoefs)+length(handles.zeropos)+length(handles.Lvalues));


 set(handles.text28,'String',num2str(compression_ratio));
 set(handles.text29,'String',num2str(PERFL2));
 set(handles.text31,'String',num2str(PERF0));

 
 %to compute SNR and display it
 numer=norm(handles.y);
 denom=norm((handles.y)-(handles.reconX));
 temp=(numer/denom);
 SNR=20*log10(temp);
 set(handles.text30,'String',num2str(SNR));
 
 
 %display the absolute maximum coefficient and the threshold
 [thr,sorh,keepapp] = ddencmp('cmp','wv',handles.y);
 set(handles.text33,'string',num2str(thr));
 set(handles.text34,'string',num2str(thr*mulfactforthr));
 
 
 %COMPUTE the signal energy at the first level approximation coefficient
 %the following artifice is employed to do the computation
 %the default values of thr,sorh,keepapp are computed using the 'ddencmp' function
 %these values are already computed in the previous step
 %Now use the 'wdencmp' function,but ignore the threshold computed in the previous step.
 %also, keep the decomposition level as 1
 %For threshold,select any value greater than 1. since keepapp=1,approximation coefficients will not be affected
 %since the threshold is greater than 1,all the detail coefficients will be truncated to zero .
 %PERFL2 will now give the energy of reconstructed signal, ie energy in the approximation
 %here, a threshold of 5 is arbitrarily selected
 %[thr,sorh,keepapp] = ddencmp('cmp','wv',handles.y);
 [XC,CXC,LXC,PERF0,PERFL2] = wdencmp('gbl',handles.y,handles.wavelet,1,5,sorh,keepapp);
 set(handles.text32,'String',num2str(PERFL2));
 
 % make the results visible by hiding the frame3, so that objects behind it can be viewed
 set(handles.frame3,'visible','off');
 
 %give a beep sound at the end
 %for i=1:1000
 %    beep
 %end







% --------------------------------------------------------------------





% --------------------------------------------------------------------
function varargout = txtwavelet_Callback(h, eventdata, handles, varargin)




% --------------------------------------------------------------------
function varargout = txtcompressedlength_Callback(h, eventdata, handles, varargin)




% --------------------------------------------------------------------





% --------------------------------------------------------------------
function varargout = txtdecomplevel_Callback(h, eventdata, handles, varargin)




% --------------------------------------------------------------------




% --------------------------------------------------------------------
function varargout = txtthrmulfact_Callback(h, eventdata, handles, varargin)




% --------------------------------------------------------------------



% --------------------------------------------------------------------
function varargout = cmdwotsthis_Callback(h, eventdata, handles, varargin)
msgbox('Matlab provides a default threshold for compression of wavelet coefficients.Generally this is a very conservative figure , giving less compression and retaining most of the coefficients. By multiplying the threshold by a number greater than 1, you effectively set a more coefficients to zero ,implying higher compression. Concomitant of course is the degradation in the reconstructed signal','Setting higher threshold')




% --------------------------------------------------------------------
function varargout = mnusave_Callback(h, eventdata, handles, varargin)




% --------------------------------------------------------------------
function varargout = mnusave1_Callback(h, eventdata, handles, varargin)

%this function will save the original signal samples, along with its sampling rate and BPS
mysignal.y=handles.y;
mysignal.FS=handles.FS;
mysignal.BPS=handles.BPS;

[f,p]=uiputfile('*.mat','Save file as');

if ~(f) 
else
    path=[p,f,'.mat'] ;
    save(path,'mysignal');
    usermessage=['The signal, along with its sampling rate and bits per sample has been saved within a structure called "mydata" at    ',path];
    msgbox(usermessage,'File saved');
end  
        

    




% --------------------------------------------------------------------
function varargout = mnusave2_Callback(h, eventdata, handles, varargin)

%this function will save the wavelet coefficient vector, commonly denoted as C .
C=handles.C;


[f,p]=uiputfile('*.mat','Save file as');

if ~(f) 
else
    path=[p,f,'.mat'] ;
    save(path,'C');
end  


% --------------------------------------------------------------------
function varargout = mnusave3_Callback(h, eventdata, handles, varargin)

%this function will save the compressed wavlet coefficients vector, commonly denoted as CXC .
%note that at this stage, encoding has not been done , thereby giving a file of same or larger size than when wavlet coeffiencents are saved
CXC=handles.CXC;


[f,p]=uiputfile('*.mat','Save file as');

if ~(f) 
else
    path=[p,f,'.mat'] ;
    save(path,'CXC');
    usermessage=['The compressed wavelet coefficients vector has been saved as: ',path,'. Note that upto this stage, no encoding has been done, thereby giving a file of same or larger size than the signal and coefficient vector'];
    msgbox(usermessage,'File saved');
end  


% --------------------------------------------------------------------
function varargout = mnusave4_Callback(h, eventdata, handles, varargin)

mydata.wavelet=handles.wavelet;
mydata.decomplevel=handles.decomplevel;
mydata.signicoefs=handles.signicoefs;
mydata.zeropos=handles.zeropos;
mydata.Lvalues=handles.Lvalues;
mydata.coeflength=handles.coeflength;
mydata.FS=handles.FS;
mydata.BPS=handles.BPS;

%mydata.signicoefs is an array of double precision floating numbers
%if we multiply it by 10000 and save it as an array of integers (2 bytes) , we reduce the file size by a factor of 4
mydata.signicoefs=mydata.signicoefs*10000;
mydata.signicoefs=int16(mydata.signicoefs);


[f,p]=uiputfile('*.mat','Save file as');

if ~(f) 
else
    f=['comp',f];
    path=[p,f,'.mat'] ;
    save(path,'mydata');
    usermessage=['The compressed and encoded coefficients have been saved in the following file: ',path,'.  This file also contains all the required information to reconstruct the original signal, ie, this file  completely represents the original signal. Use the command "reconstruct" to get the original signal.'];
    msgbox(usermessage,'File saved');
end

% --------------------------------------------------------------------
function varargout = mnusave5_Callback(h, eventdata, handles, varargin)
%this menu item will save the reconstructed signal (.wav file) directly
[f,p]=uiputfile('*.wav','Save file as');

if ~(f) 
else
    path=[p,f,'.wav'] ;
    wavwrite(handles.reconX,handles.FS,handles.BPS,path);
end


% --------------------------------------------------------------------
function varargout = mnuclose_Callback(h, eventdata, handles, varargin)
close;



% --------------------------------------------------------------------
function varargout = mnuh_Callback(h, eventdata, handles, varargin)




% --------------------------------------------------------------------
function varargout = mnuhelp_Callback(h, eventdata, handles, varargin)
mystr=[pwd '\help\speech compression help\main.htm'];
open(mystr);



% --------------------------------------------------------------------
function varargout = mnucredits_Callback(h, eventdata, handles, varargin)

helpdlg('This software has been developed for educational purposes only. Feel free to drop in your comments at shivramangiri@yahoo.co.uk');



% --------------------------------------------------------------------
function varargout = mnuplot_Callback(h, eventdata, handles, varargin)




% --------------------------------------------------------------------
function varargout = mnuplotting_Callback(h, eventdata, handles, varargin)
figure;
subplot(2,1,1);
plot(handles.y,'b');
title('Original Signal');
subplot(2,1,2);
plot(handles.reconX,'r');
title('Reconstructed signal');







% --------------------------------------------------------------------
function varargout = cmdhelp_Callback(h, eventdata, handles, varargin)

mystr=[pwd '\help\speech compression help\wavelets.htm'];
open(mystr);



% --------------------------------------------------------------------
function varargout = mnucoeffs_Callback(h, eventdata, handles, varargin)
n=length(handles.C);
o=ones(1,n);      %matrix of ones. this is later used to plot the threshold line
mythreshold=(str2num(get(handles.text34,'string')))*o;    %this will be used to plot a line for threshold
xaxis=1:n;

%now to draw a vertical line to separate the approximation and detail coeff
%we will plot 100 points on this line
appcoef_max_index=handles.Lvalues(1);
xpos=appcoef_max_index*(ones(1,100));
ypos=linspace(-1,1,100);

figure;
subplot(2,1,1);
plot(xaxis,handles.C,'b',xaxis,mythreshold,'g',xpos,ypos,'k');
title('Original Wavelet coefficients.');
text(appcoef_max_index,-0.8,'The black vertical line separates approx and details coeff');
text((n/2),0.5,'The green line is the threshold line')

subplot(2,1,2);

plot(xaxis,handles.CXC,'r',xaxis,mythreshold,'g',xpos,ypos,'k');
title('Wavelet coefficients after compression');
